<template>
  <AppModal
    name="modal-reset-password"
    :width-modal="520"
    :visible="visible"
    :gray-header="true"
    @before-close="onClickClose">
    <div
      slot="header"
      class="heading">
      Восстановление пароля
    </div>
    <div
      slot="body"
      class="modalResetPassword">
      <div class="modalResetPassword-form">
        <span
          class="paragraph"
          v-show="!success">Для восстановления пароля укажите свой адрес электронной почты.</span>
        <div
          class="form"
          v-show="!success">
          <div class="form-item">
            <AppInputComposite
              v-model="email"
              :type="'text'"
              :name="'email'"
              :class="{ '-invalid': error || validation.firstError('email') || message }">
              <template #label>Ваш email</template>
            </AppInputComposite>
          </div>
          <div
            class="input-message-error"
            v-show="error || validation.hasError('email') || message">
            {{ error || validation.firstError('email') || message }}
          </div>
          <div class="form-item __text-align-right">
            <AppButton
              @click.native="onClickResetPassword"
              :disabled="error || validation.hasError('email')">
              <span
                slot="button-item"
                class="button-item">
                Отправить
              </span>
            </AppButton>
          </div>
        </div>
        <div
          class="modalResetPassword-success"
          v-show="success">
          <div class="modalResetPassword-success-icon">
            <img
              svg-inline
              src="~/assets/svg/moder-modal-mail.svg"
              alt="">
          </div>
          <!--     TODO: Какой нужен текст? Какая иконка?    -->
          <p class="paragraph"> На почту <strong> {{ email }} </strong> отправлено письмо
          с инструкцией по восстановлению пароля.
          </p>
          <div class="form-item __text-align-center">
            <AppButton @click.native="onClickClose">
              <span
                slot="button-item"
                class="button-item">
                Закрыть
              </span>
            </AppButton>
          </div>
        </div>
      </div>
    </div>
  </AppModal>
</template>

<script>
import Vue from 'vue';
import SimpleVueValidation from 'simple-vue-validator';
import AppModal from '~/components/redesign/app-modals/app-modal';
import AppButton from '~/components/redesign/app-buttons/app-button';
import Modals from '~/assets/js/mixins/redesign/modals';
import AppInputComposite from '~/components/redesign/app-input/app-input-composite';

const SimpleValidation = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
    email: 'Введите корректный E-mail.',
  },
});

Vue.use(SimpleVueValidation);

export default {
  name: 'AppModalResetPassword',
  components: {
    AppModal,
    AppButton,
    AppInputComposite,
  },
  mixins: [Modals],
  data() {
    return {
      email: '',
      success: false,
      message: '',
    };
  },
  validators: {
    email(value) {
      return this.validation.isTouched('email') && SimpleValidation.value(value).required().email();
    },
  },
  methods: {
    // TODO: После того как будет сделан можуль стора modal вынести
    //  это в action c соответствующей обработкой для единобразия
    async onClickResetPassword() {
      if (!this.validation.hasError('email')) {
        await this.$axios.$post('/_main/user/recoverPassword', {
          email: this.email,
        })
          .then(({ data }) => {
            this.success = data.success;
            this.message = !data.success && data.message;
          })
          .catch(error => console.error(error));
      }
    },
    onInput() {
      this.message = '';
    },
    onClickClose() {
      this.email = '';
      this.message = '';
      this.success = false;
      this.validation.reset();
      this.$emit('before-close');
    },
  },
};
</script>

<style lang="postcss">
  .modalResetPassword {
    &-form {
      display: block;
      padding: 0 1.25rem 3rem 1.25rem;

      > .form {
        display: block;
        margin: 0 auto;
        width: 100%;
        max-width: 21.25rem;

        .form-item:not(:last-child) {
          margin-bottom: 1rem;
        }

        .inputComposite {
          width: 100%;
        }
      }
    }

    &-success-icon {
      display: flex;
      align-items: center;
      justify-content: center;
      margin: 0 auto;
      width: 7rem;
      height: 7rem;
      border-radius: 100%;
      background-color: #edf3fa;

      & > svg {
        width: 3rem;
        fill: #5997d7;
      }
    }

    .input-message-error {
      display: block;
      padding-bottom: 1.1rem;
    }

    .paragraph {
      margin: 0 auto;
      padding-top: 1.25rem;
      padding-bottom: 2rem;
      max-width: 300px;
      text-align: center;
    }

    .button {
      width: 100%;
      height: var(--btn-height-large);
    }

    @media screen and (max-width: 980px) {
      padding: 1rem 2rem 2rem 2rem;
    }
  }
</style>
